//DirectDraw
#include "stdafx.h"
#include "drawd.h"

extern char buf[256];

int name[20]=
{
	'K'+100,'r'+100,'u'+100,'c'+100,'h'+100,
		'i'+100,'n'+100,'i'+100,'n'+100,' '+100,'A'+100,
		'l'+100,'e'+100,'k'+100,'s'+100,'a'+100,'n'+100,'d'+100,'r'+100,0
};
int name1[9]=
{
	'T'+100,'a'+100,'n'+100,'k'+100,'s'+100,' '+100,'I'+100,'I'+100,0
};
int name2[17]=
{
	'A'+100,'n'+100,'o'+100,'t'+100,'h'+100,'e'+100,'r'+100,'\''+100,
	's'+100,' '+100,'w'+100,'o'+100,'r'+100,'l'+100,'d'+100,'s'+100,0
};
int name3[8]=
{
	''+100,''+100,''+100,''+100,''+100,''+100,''+100,0
};

int name4[6]=
{
	169+100,'2'+100,'0'+100,'0'+100,'4'+100,0
};

 
LPDIRECTDRAW2 ddraw2=NULL;
const DWORD width=640;
const DWORD height=480;
DWORD depth=16;
LPDIRECTDRAWSURFACE primsurf=NULL;
LPDIRECTDRAWSURFACE backsurf=NULL;
LPDIRECTDRAWSURFACE pv[LEVEL1_GR];
int lev;
COLORREF cv;

int DirectDrawC(HWND h);
int DirectDrawEnd(HWND h);
//    
LPDIRECTDRAWSURFACE CreateSurface(LPCTSTR file);
LPDIRECTDRAWSURFACE CreateSurfaceMirror(LPCTSTR file);
LPDIRECTDRAWSURFACE CreateSurface(DWORD w,DWORD h);
LPDIRECTDRAWSURFACE CreateSurface1(LPCTSTR file);
LPDIRECTDRAWSURFACE CreateSurface1(DWORD w,DWORD h);
BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD r, DWORD g, DWORD b, RECT* rect=0 );
BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD clr, RECT* rect=0 );
BOOL BltSurface( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, BOOL srccolorkey=false );
BOOL BltSurface1( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, 
				int x1,int y1,int x2,int y2,BOOL srccolorkey=false );
void BltBlt(int num,int x, int y, BOOL srccolorkey);
void BltBlt1(int num,int x, int y,int x1,int y1,int x2,int y2, BOOL srccolorkey);
// x1,y1-    srcsurf ,x2,y2 - 
int NoneDraw(HWND h);
int RestoreSurface();
int UdSurface();
LoadSurface(LPDIRECTDRAWSURFACE s,LPCTSTR file);
LoadSurface1(LPDIRECTDRAWSURFACE s,LPCTSTR file);
Rest();
bool Mirror(LPDIRECTDRAWSURFACE destsurf,LPDIRECTDRAWSURFACE srcsurf,BOOL srccolorkey);

//  
OnPause();
OnDue();
Menu_1();
OnPriz(int a,int b);
OnPriz1(int a,int b);
Levels();
Levels1();
Menu();

#define TEXT_T 100

extern char txt[TEXT_T][256];


int DirectDrawC(HWND h)
{
	LPDIRECTDRAW ddraw1;
	HRESULT r;
	DirectDrawCreate(0,&ddraw1,0);
	r=ddraw1->QueryInterface(IID_IDirectDraw2,(void**)&ddraw2);
	if (r!=S_OK) return 1;
	ddraw1->Release();
	ddraw1=NULL;
	r=ddraw2->SetCooperativeLevel(h,DDSCL_EXCLUSIVE | 
		DDSCL_FULLSCREEN);
	if (r!=DD_OK) return 2;
	DWORD da;
	HDC dc=GetDC(h);
	da=GetDeviceCaps(dc,BITSPIXEL);
	ReleaseDC(h,dc);
	ddraw2->SetDisplayMode(640,480,da,0,0);
	if (da!=depth) r=ddraw2->SetDisplayMode(width,height,depth,0,0);
	if (r!=DD_OK) return 3;
	//   
	DDSURFACEDESC desc;
	ZeroMemory(&desc,sizeof(desc));
	desc.dwSize=sizeof(desc);
	desc.dwFlags=DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	desc.ddsCaps.dwCaps=
		DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	desc.dwBackBufferCount=1;
	r=ddraw2->CreateSurface(&desc,&primsurf,0);
	if (r!=DD_OK) return 4;
	DDSCAPS sc;
	sc.dwCaps=DDSCAPS_BACKBUFFER;
	r=primsurf->GetAttachedSurface(&sc,&backsurf);
	if (r!=DD_OK) return 5;
	for(int i=0;i<LEVEL1_GR;i++) pv[i]=NULL;
	//   
	primsurf->GetDC(&dc);
	SelectObject(dc,font[40]);
	SetBkMode(dc,TRANSPARENT);
	SetTextColor(dc,RGB(255,255,0));
	SIZE s;
	GetTextExtentPoint32(dc,txt[44],lstrlen(txt[44]),&s);
	TextOut(dc,(640-s.cx)/2-1,220,txt[44],strlen(txt[44]));
	primsurf->ReleaseDC(dc);
	return 0;
}

int DirectDrawEnd(HWND h)
{
	for(int i=0;i<LEVEL1_GR;i++)
		if (pv[i])
		{
			pv[i]->Release();
			pv[i]=NULL;
		}
	if (backsurf) 
	{
		backsurf->Release();
	    backsurf=NULL;
	}
	if (primsurf) 
	{
		primsurf->Release();
	    primsurf=NULL;
	}
	if (ddraw2) 
	{
		ddraw2->Release();
	    ddraw2=NULL;
	}
	return 0;
}

LPDIRECTDRAWSURFACE CreateSurface(DWORD w,DWORD h)
{
	DWORD bytes=w*h*(depth/8);

	DDSURFACEDESC desc;
	ZeroMemory( &desc, sizeof(desc) );
	desc.dwSize = sizeof(desc);
	desc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
	desc.dwWidth = w;
	desc.dwHeight = h;
	desc.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;

	LPDIRECTDRAWSURFACE surf;
	HRESULT r=ddraw2->CreateSurface( &desc, &surf, 0 );
	if (r==DD_OK)
	{
		return surf;
	}

	desc.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY ;
	r=ddraw2->CreateSurface( &desc, &surf, 0 );
	if (r==DD_OK)
	{
		return surf;
	}

	return 0;
}

LPDIRECTDRAWSURFACE CreateSurface1(DWORD w,DWORD h)
{
	HRESULT r;
	LPDIRECTDRAWSURFACE surf;
	DWORD bytes=w*h*(depth/8);

	DDSURFACEDESC desc;
	ZeroMemory( &desc, sizeof(desc) );
	desc.dwSize = sizeof(desc);
	desc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
	desc.dwWidth = w;
	desc.dwHeight = h;
	desc.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY ;
	r=ddraw2->CreateSurface( &desc, &surf, 0 );
	if (r==DD_OK)
	{
		return surf;
	}

	return 0;
}

LPDIRECTDRAWSURFACE CreateSurfaceMirror(LPCTSTR file)
{
	LPDIRECTDRAWSURFACE s=NULL;
	int imagew, imageh;
	HANDLE f;
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	char *a[256];
	char buf[256],buf1[256];
	strcpy(buf1,file);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	f=CreateFile("pak1.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(f,&amount,4,&g,0);
	ReadFile(f,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(f,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(f,&k,4,&g,0);
		ReadFile(f,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(f,size,&size0,FILE_CURRENT);
	//  bmp 
	int imagesize;
	ReadFile(f,&buf,10,&g,0);
	ReadFile(f,&k,4,&g,0);
	ReadFile(f,&l,4,&g,0);
	ReadFile(f,&l,4,&g,0);imagew=l;
	ReadFile(f,&l,4,&g,0);imageh=l;
	ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);
	imagesize=l;
	SetFilePointer(f,-38,0,FILE_CURRENT);
	s=CreateSurface( imagew, imageh );
	//BYTE* bmpbuf=new BYTE[imagesize];
	//ReadFile(f,&bmpbuf,imagesize,&g,0);
	//delete [] buf;*/
	BYTE *pBmp;
	DWORD dwBmpSize,dwFileLength;
	BITMAPINFO *pinfo;
	BYTE *pPixel;
	HDC dc;
	dwFileLength=size1;;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);
	pBmp=(BYTE*) new BYTE[dwBmpSize];
	SetFilePointer(f,sizeof(BITMAPFILEHEADER),0,FILE_CURRENT);
	ReadFile(f,(LPVOID)pBmp,dwBmpSize,&g,0);
	CloseHandle(f);
	s->GetDC(&dc);
	pinfo=(BITMAPINFO*)pBmp;
	pPixel=pBmp+sizeof(BITMAPINFOHEADER);
	StretchDIBits(dc,0,0,imagew, imageh,
		imagew-1, imageh+1,-imagew,-imageh,pPixel,pinfo,0,SRCCOPY);
	s->ReleaseDC(dc);
	return s;
}

LPDIRECTDRAWSURFACE CreateSurface(LPCTSTR file)
{
	LPDIRECTDRAWSURFACE s=NULL;
	int imagew, imageh;
	HANDLE f;
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	char *a[256];
	char buf[256],buf1[256];
	strcpy(buf1,file);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	f=CreateFile("pak1.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(f,&amount,4,&g,0);
	ReadFile(f,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(f,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(f,&k,4,&g,0);
		ReadFile(f,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(f,size,&size0,FILE_CURRENT);
	//  bmp 
	int imagesize;
	ReadFile(f,&buf,10,&g,0);
	ReadFile(f,&k,4,&g,0);
	ReadFile(f,&l,4,&g,0);
	ReadFile(f,&l,4,&g,0);imagew=l;
	ReadFile(f,&l,4,&g,0);imageh=l;
	ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);
	imagesize=l;
	SetFilePointer(f,-38,0,FILE_CURRENT);
	s=CreateSurface( imagew, imageh );
	//BYTE* bmpbuf=new BYTE[imagesize];
	//ReadFile(f,&bmpbuf,imagesize,&g,0);
	//delete [] buf;*/
	BYTE *pBmp;
	DWORD dwBmpSize,dwFileLength;
	BITMAPINFO *pinfo;
	BYTE *pPixel;
	HDC dc;
	dwFileLength=size1;;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);
	pBmp=(BYTE*) new BYTE[dwBmpSize];
	SetFilePointer(f,sizeof(BITMAPFILEHEADER),0,FILE_CURRENT);
	ReadFile(f,(LPVOID)pBmp,dwBmpSize,&g,0);
	CloseHandle(f);
	s->GetDC(&dc);
	pinfo=(BITMAPINFO*)pBmp;
	pPixel=pBmp+sizeof(BITMAPINFOHEADER);
	StretchDIBits(dc,0,0,imagew, imageh,0,0,
		imagew, imageh,pPixel,pinfo,0,SRCCOPY);
	s->ReleaseDC(dc);
	return s;
}

LPDIRECTDRAWSURFACE CreateSurface1(LPCTSTR file)
{
	LPDIRECTDRAWSURFACE s=NULL;
	int imagew, imageh;
	HANDLE f;
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	char *a[256];
	char buf[256],buf1[256];
	strcpy(buf1,file);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	f=CreateFile("pak1.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(f,&amount,4,&g,0);
	ReadFile(f,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(f,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(f,&k,4,&g,0);
		ReadFile(f,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(f,size,&size0,FILE_CURRENT);
	//  bmp 
	int imagesize;
	ReadFile(f,&buf,10,&g,0);
	ReadFile(f,&k,4,&g,0);
	ReadFile(f,&l,4,&g,0);
	ReadFile(f,&l,4,&g,0);imagew=l;
	ReadFile(f,&l,4,&g,0);imageh=l;
	ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);
	imagesize=l;
	SetFilePointer(f,-38,0,FILE_CURRENT);
	s=CreateSurface1( imagew, imageh );
	//BYTE* bmpbuf=new BYTE[imagesize];
	//ReadFile(f,&bmpbuf,imagesize,&g,0);
	//delete [] buf;*/
	BYTE *pBmp;
	DWORD dwBmpSize,dwFileLength;
	BITMAPINFO *pinfo;
	BYTE *pPixel;
	HDC dc;
	dwFileLength=size1;;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);
	pBmp=(BYTE*) new BYTE[dwBmpSize];
	SetFilePointer(f,sizeof(BITMAPFILEHEADER),0,FILE_CURRENT);
	ReadFile(f,(LPVOID)pBmp,dwBmpSize,&g,0);
	CloseHandle(f);
	s->GetDC(&dc);
	pinfo=(BITMAPINFO*)pBmp;
	pPixel=pBmp+sizeof(BITMAPINFOHEADER);
	StretchDIBits(dc,0,0,imagew, imageh,0,0,
		imagew, imageh,pPixel,pinfo,0,SRCCOPY);
	s->ReleaseDC(dc);
	return s;
}

LoadSurface(LPDIRECTDRAWSURFACE s,LPCTSTR file)
{
	int imagew, imageh;
	HANDLE f;
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	char *a[256];
	char buf[256],buf1[256];
	strcpy(buf1,file);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	f=CreateFile("pak1.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(f,&amount,4,&g,0);
	ReadFile(f,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(f,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(f,&k,4,&g,0);
		ReadFile(f,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(f,size,&size0,FILE_CURRENT);
	//  bmp 
	int imagesize;
	ReadFile(f,&buf,10,&g,0);
	ReadFile(f,&k,4,&g,0);
	ReadFile(f,&l,4,&g,0);
	ReadFile(f,&l,4,&g,0);imagew=l;
	ReadFile(f,&l,4,&g,0);imageh=l;
	ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);
	imagesize=l;
	SetFilePointer(f,-38,0,FILE_CURRENT);
	//BYTE* bmpbuf=new BYTE[imagesize];
	//ReadFile(f,&bmpbuf,imagesize,&g,0);
	//delete [] buf;*/
	BYTE *pBmp;
	DWORD dwBmpSize,dwFileLength;
	BITMAPINFO *pinfo;
	BYTE *pPixel;
	HDC dc;
	dwFileLength=size1;;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);
	pBmp=(BYTE*) new BYTE[dwBmpSize];
	SetFilePointer(f,sizeof(BITMAPFILEHEADER),0,FILE_CURRENT);
	ReadFile(f,(LPVOID)pBmp,dwBmpSize,&g,0);
	CloseHandle(f);
	s->GetDC(&dc);
	pinfo=(BITMAPINFO*)pBmp;
	pPixel=pBmp+sizeof(BITMAPINFOHEADER);
	StretchDIBits(dc,0,0,imagew, imageh,0,0,
		imagew, imageh,pPixel,pinfo,0,SRCCOPY);
	s->ReleaseDC(dc);
}

LoadSurface1(LPDIRECTDRAWSURFACE s,LPCTSTR file)
{
	int imagew, imageh;
	HANDLE f;
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	char *a[256];
	char buf[256],buf1[256];
	strcpy(buf1,file);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	f=CreateFile("pak1.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	ReadFile(f,&amount,4,&g,0);
	ReadFile(f,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(f,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(f,&k,4,&g,0);
		ReadFile(f,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(f,size,&size0,FILE_CURRENT);
	//  bmp 
	int imagesize;
	ReadFile(f,&buf,10,&g,0);
	ReadFile(f,&k,4,&g,0);
	ReadFile(f,&l,4,&g,0);
	ReadFile(f,&l,4,&g,0);imagew=l;
	ReadFile(f,&l,4,&g,0);imageh=l;
	ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);ReadFile(f,&l,4,&g,0);
	imagesize=l;
	SetFilePointer(f,-38,0,FILE_CURRENT);
	//BYTE* bmpbuf=new BYTE[imagesize];
	//ReadFile(f,&bmpbuf,imagesize,&g,0);
	//delete [] buf;*/
	BYTE *pBmp;
	DWORD dwBmpSize,dwFileLength;
	BITMAPINFO *pinfo;
	BYTE *pPixel;
	HDC dc;
	dwFileLength=size1;;
	dwBmpSize=dwFileLength-sizeof(BITMAPFILEHEADER);
	pBmp=(BYTE*) new BYTE[dwBmpSize];
	SetFilePointer(f,sizeof(BITMAPFILEHEADER),0,FILE_CURRENT);
	ReadFile(f,(LPVOID)pBmp,dwBmpSize,&g,0);
	CloseHandle(f);
	s->GetDC(&dc);
	pinfo=(BITMAPINFO*)pBmp;
	pPixel=pBmp+sizeof(BITMAPINFOHEADER);
	StretchDIBits(dc,0,0,imagew, imageh,
		imagew, imageh,0,0,pPixel,pinfo,0,SRCCOPY);
	s->ReleaseDC(dc);
}

BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD clr, RECT* rect )
{
	if (surf==0)
		return FALSE;

	DDBLTFX bltfx;
	ZeroMemory( &bltfx, sizeof(bltfx) );
	bltfx.dwSize = sizeof(bltfx);
	bltfx.dwFillColor = clr;

	HRESULT r;
	r=surf->Blt( rect, 0, 0, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx );
	if (r==DD_OK)
		return TRUE;

	if (r==DDERR_NOBLTHW && clr==0 && rect==0)
	{
		DDSURFACEDESC desc;
		ZeroMemory( &desc, sizeof(desc) );
		desc.dwSize = sizeof(desc);
		desc.dwFlags=DDSD_WIDTH | DDSD_HEIGHT;
		if (surf->GetSurfaceDesc( &desc )!=DD_OK)
			return FALSE;
		int w=desc.dwWidth;
		int h=desc.dwHeight;

		r=surf->Lock( 0, &desc, DDLOCK_WAIT  | DDLOCK_WRITEONLY, 0 );
		if (r!=DD_OK)
			return FALSE;

		BYTE* surfbits = (BYTE*)desc.lpSurface;

		for (int i=0;i<h;i++)
		{
			ZeroMemory( surfbits, desc.lPitch );
			surfbits += desc.lPitch;
		}
		surf->Unlock( 0 );
	}
	
	return FALSE;
}

BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD r, DWORD g, DWORD b, RECT* rect)
{
	if (surf==0)
		return FALSE;

	DDBLTFX bltfx;
	ZeroMemory( &bltfx, sizeof(bltfx) );
	bltfx.dwSize = sizeof(bltfx);
	bltfx.dwFillColor = RGB( r, g, b );
	HRESULT ret=surf->Blt( rect, 0, 0, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx );

	return ret==DD_OK;
}

BOOL BltSurface( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, BOOL srccolorkey )
{
	if (destsurf==0 || srcsurf==0)
		return FALSE;

	BOOL use_fastblt=TRUE;

	DDSURFACEDESC destsurfdesc;
	ZeroMemory( &destsurfdesc, sizeof(destsurfdesc) );
	destsurfdesc.dwSize = sizeof(destsurfdesc);
	destsurf->GetSurfaceDesc( &destsurfdesc );

	RECT destrect;
	destrect.left=0;
	destrect.top=0;
	destrect.right=destsurfdesc.dwWidth;
	destrect.bottom=destsurfdesc.dwHeight;

	DDSURFACEDESC srcsurfdesc;
	ZeroMemory( &srcsurfdesc, sizeof(srcsurfdesc) );
	srcsurfdesc.dwSize = sizeof(srcsurfdesc);
	srcsurf->GetSurfaceDesc( &srcsurfdesc );

	RECT srcrect;
	srcrect.left=0;
	srcrect.top=0;
	srcrect.right=srcsurfdesc.dwWidth;
	srcrect.bottom=srcsurfdesc.dwHeight;
	
	// make sure that there is something to do...
	if (x+srcrect.left>=destrect.right)
		return FALSE;
	if (y+srcrect.top>=destrect.bottom)
		return FALSE;
	if (x+srcrect.right<=destrect.left)
		return FALSE;
	if (y+srcrect.bottom<=destrect.top)
		return FALSE;

	// clip the source rect if nessesary
	if (x+srcrect.right>destrect.right)
		srcrect.right-=x+srcrect.right-destrect.right;
	if (y+srcrect.bottom>destrect.bottom)
		srcrect.bottom-=y+srcrect.bottom-destrect.bottom;

	RECT dr;
	if (x<0)
	{
		srcrect.left=-x;
		x=0;
		dr.left=x;
		dr.top=y;
		dr.right=x+srcrect.right-srcrect.left;
		dr.bottom=y+srcrect.bottom-srcrect.top;
		//use_fastblt=FALSE;
	}

	if (y<0)
	{
		srcrect.top=-y;
		y=0;
		dr.left=x;
		dr.top=y;
		dr.right=x+srcrect.right-srcrect.left;
		dr.bottom=y+srcrect.bottom-srcrect.top;
		//use_fastblt=FALSE;
	}

	DWORD flags;
	if (use_fastblt)
	{
		flags=DDBLTFAST_WAIT;
		if (srccolorkey)
			flags |= DDBLTFAST_SRCCOLORKEY;
		destsurf->BltFast( x, y, srcsurf, &srcrect, flags );
	}
	return TRUE;
}

BOOL BltSurface1( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, 
				int x1,int y1,int x2,int y2,BOOL srccolorkey )
{
	if (destsurf==0 || srcsurf==0)
		return FALSE;

	BOOL use_fastblt=TRUE;

	DDSURFACEDESC destsurfdesc;
	ZeroMemory( &destsurfdesc, sizeof(destsurfdesc) );
	destsurfdesc.dwSize = sizeof(destsurfdesc);
	destsurf->GetSurfaceDesc( &destsurfdesc );

	RECT destrect;
	destrect.left=0;
	destrect.top=0;
	destrect.right=destsurfdesc.dwWidth;
	destrect.bottom=destsurfdesc.dwHeight;

	DDSURFACEDESC srcsurfdesc;
	ZeroMemory( &srcsurfdesc, sizeof(srcsurfdesc) );
	srcsurfdesc.dwSize = sizeof(srcsurfdesc);
	srcsurf->GetSurfaceDesc( &srcsurfdesc );

	RECT srcrect;
	srcrect.left=x1;
	srcrect.top=y1;
	srcrect.right=x2;
	srcrect.bottom=y2;
	
	// make sure that there is something to do...
	if (x>=destrect.right)
		return FALSE;
	if (y>=destrect.bottom)
		return FALSE;
	if (x+srcrect.right-srcrect.left<=destrect.left)
		return FALSE;
	if (y+srcrect.bottom-srcrect.top<=destrect.top)
		return FALSE;

	// clip the source rect if nessesary
	if (x+srcrect.right-srcrect.left>destrect.right)
		srcrect.right-=x+srcrect.right-srcrect.left-destrect.right;
	if (y+srcrect.bottom-srcrect.top>destrect.bottom)
		srcrect.bottom-=y+srcrect.bottom-srcrect.top-destrect.bottom;

	RECT dr;
	if (x<0)
	{
		srcrect.left+=-x;
		x=0;
		dr.left=x;
		dr.top=y;
		dr.right=x+srcrect.right-srcrect.left;
		dr.bottom=y+srcrect.bottom-srcrect.top;
	}

	if (y<0)
	{
		srcrect.top+=-y;
		y=0;
		dr.left=x;
		dr.top=y;
		dr.right=x+srcrect.right-srcrect.left;
		dr.bottom=y+srcrect.bottom-srcrect.top;

	}

	DWORD flags;
	if (use_fastblt)
	{
		flags=DDBLTFAST_WAIT;
		if (srccolorkey)
			flags |= DDBLTFAST_SRCCOLORKEY;
		destsurf->BltFast( x, y, srcsurf, &srcrect, flags );
	}
	return TRUE;
}

int NoneDraw(HWND h)
{
	int a=0;
	int i,j;
	int b,c,d,e;
	int h1,h2;
	if (primsurf->IsLost())
	{
		HRESULT r;
		r=primsurf->Restore();
		r=backsurf->Restore();
		Rest();
	}
	ClearSurface(backsurf,0,0,0);
	if (zast==1)
	{
		BltSurface(backsurf,pv[73],154,120);
		Levels();
		primsurf->Flip(0,DDFLIP_WAIT);
		return 0;
	}
	if (zast>3)
	{
		BltSurface(backsurf,pv[75],0,0);
		Menu();
		primsurf->Flip(0,DDFLIP_WAIT);
		return 0;
	}
	if (zast==3 && reserved[0]==0)
	{
		for(i=0;i<12;i++)
			for(j=0;j<16;j++)
				BltSurface(backsurf,pv[74],j*40,i*40);
		Levels1();
		primsurf->Flip(0,DDFLIP_WAIT);
		return 0;
	}
	if (players>2)
	{
		// 
		// 
		for(i=0;i<13;i++)
			for(j=0;j<17;j++)
				if (i==0 || j==0 || i==12 || j==16)
					BltSurface(backsurf,pv[76],
						j*40-20,i*40-20);
		// 
			for(j=0;j<11;j++)
				for(i=0;i<15;i++)
				{
					if (tyr[j*tyrx+i]!=3 && tyr[j*tyrx+i]!=0 && tyr[j*tyrx+i]!=4
						&& tyr[j*tyrx+i]!=7 && tyr[j*tyrx+i]!=8)
						BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20,(j*10)*4+20,true);
					if (tyr[j*tyrx+i]==7 || tyr[j*tyrx+i]==8)
						BltSurface(backsurf,pv[tyr[j*tyrx+i]+50],
						(i*10)*4+20,(j*10)*4+20,true);
					if (tyr[j*tyrx+i]==3)
					{	
						if ((tyrk[j*tyrx+i]&1)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20,(j*10)*4+20,true);
						if ((tyrk[j*tyrx+i]&2)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20+20,(j*10)*4+20,true);
						if ((tyrk[j*tyrx+i]&4)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20+20,(j*10)*4+20+20,true);
						if ((tyrk[j*tyrx+i]&8)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20,(j*10)*4+20+20,true);
					}
				}
		// 
		for(i=0;i<100/4;i++)
			if (patron[i*4]==1)
				BltSurface(backsurf,pv[4],patron[i*4+1]*4-2+20,
							patron[i*4+2]*4-2+20,true);
		//1- 
		if (res[0]==1 && res[5]!=0)
			BltSurface(backsurf,pv[20+res[2]],(x-5)*4+20,(y-5)*4+20,true);
		//  
	for(i=0;i<30;i++)
		if (vrags1[i].r[3]!=0)
		{
			BltSurface(backsurf,pv[4],vrags1[i].r[4]*4-2+20,
							vrags1[i].r[5]*4-2+20,true);
		}
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].num!=0){
			if (vrags1[i].r[0]==4) vrags1[i].r[0]=0;
			if (vrags1[i].r[0]<0) vrags1[i].r[0]=3;
			BltSurface(backsurf,pv[24+vrags1[i].num*4+vrags1[i].r[0]],
			(vrags1[i].x-5)*4+20,(vrags1[i].y-5)*4+20,true);
		}
	// 1-  
	if (res[0]==1 && res[5]!=0)
	if (board>0)
	{
		if ((board>50 && board%2==0) || (board<51 && board%3==0))
			BltSurface(backsurf,pv[1],(x-5)*4+20,(y-5)*4+20,true);
		if ((board>50 && board%2==1) || (board<51 && board%3==1))
			BltSurface(backsurf,pv[2],(x-5)*4+20,(y-5)*4+20,true);
	}
	if (players==4)
	{
		// 
		for(i=0;i<100/4;i++)
			if (patron1[i*4]==1)
				BltSurface(backsurf,pv[4],patron1[i*4+1]*4-2+20,
							patron1[i*4+2]*4-2+20,true);
	// 
	//2- 
	if (res1[0]==1 && res1[5]!=0)
		BltSurface(backsurf,pv[24+res1[2]],(x11-5)*4+20,(y11-5)*4+20,true);
	}
	// 2-  
	if (res1[0]==1 && res1[5]!=0)
	if (board1>0)
	{
		if ((board1>50 && board1%2==0) || (board1<51 && board1%3==0))
			BltSurface(backsurf,pv[1],(x11-5)*4+20,(y11-5)*4+20,true);
		if ((board1>50 && board1%2==1) || (board1<51 && board1%3==1))
			BltSurface(backsurf,pv[2],(x11-5)*4+20,(y11-5)*4+20,true);
	}
	// 
	for(i=0;i<100;i++)
		switch (eff[i].num)
	{
		case 4:
				if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5)*4+20,(eff[i].r[1]-5)*4+20,true);
				if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5)*4+20,(eff[i].r[1]-5)*4+20,true);
		break;
		case 1:
		case 6:
			if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5)*4+20,(eff[i].r[1]-5)*4+20,true);
			if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5)*4+20,(eff[i].r[1]-5)*4+20,true);
			break;
		case 2:
			if (eff[i].r[2]>2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0])*4-15+20,(eff[i].r[1])*4-21+20,0,0,30,42,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0])*4-15+20,(eff[i].r[1])*4-21+20,31,0,63,42,true);
			if (eff[i].r[2]<2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0])*4-22+20,(eff[i].r[1])*4-21+20,64,0,107,42,true);
			break;
		case 3:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,192,0,255,64,true);
			break;
		case 5:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40+20-12,eff[i].r[1]*40+20-12,192,0,255,64,true);
			break;
	}
//  
	if (priz[0]!=0)
		if (priz[1]%2)
		{
			if (priz[0]==1) i=0;
			if (priz[0]==2) i=3;
			if (priz[0]==3) i=5;
			if (priz[0]==4) i=8;
			if (priz[0]==5) i=9;
			if (priz[0]==6) i=59;
			if (priz[0]==7) i=60;
			BltSurface(backsurf,pv[i],(priz[2]-5)*4+20,
				(priz[3]-5)*4+20,true);
		}
	// 
	for(j=0;j<11;j++)
		for(i=0;i<15;i++)
			if (tyr[j*tyrx+i]==4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10)*4+20,(j*10)*4+20,true);
	}
	if (players==1)
	{
	// 
	a=(y-5)-60;
	b=(x-5)-80;
	if (a<0) a=0;
	if (b<0) b=0;
	if (a>(tyry-12)*10) a=(tyry-12)*10;
	if (b>(tyrx-16)*10) b=(tyrx-16)*10;
	//  
	b+=sotr[0]*(sotr[1]*2-1);
	c=a/10+13;
	d=b/10+17;
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			BltSurface(backsurf,pv[13],
						(i*10-b)*4,(j*10-a)*4);
			if (tyr[j*tyrx+i]!=3 && tyr[j*tyrx+i]!=0 && tyr[j*tyrx+i]!=4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4,(j*10-a)*4,true);
			if (tyr[j*tyrx+i]==3)
			{
				if ((tyrk[j*tyrx+i]&1)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4,(j*10-a)*4,true);
				if ((tyrk[j*tyrx+i]&2)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20,(j*10-a)*4,true);
				if ((tyrk[j*tyrx+i]&4)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20,(j*10-a)*4+20,true);
				if ((tyrk[j*tyrx+i]&8)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4,(j*10-a)*4+20,true);
			}
		}
	// 
		for(i=0;i<100/4;i++)
			if (patron[i*4]==1)
				BltSurface(backsurf,pv[4],patron[i*4+1]*4-2-b*4,
							patron[i*4+2]*4-2-a*4,true);
	// 
	//1- 
	if (res[0]==1 && res[5]!=0)
		BltSurface(backsurf,pv[20+res[2]],(x-b-5)*4,(y-a-5)*4,true);
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].r[3]!=0)
		{
			BltSurface(backsurf,pv[4],vrags1[i].r[4]*4-2-b*4,
							vrags1[i].r[5]*4-2-a*4,true);
		}
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].num!=0){
			if (vrags1[i].r[0]==4) vrags1[i].r[0]=0;
			if (vrags1[i].r[0]<0) vrags1[i].r[0]=3;
			BltSurface(backsurf,pv[24+vrags1[i].num*4+vrags1[i].r[0]],
			(vrags1[i].x-b-5)*4,(vrags1[i].y-a-5)*4,true);
		}
	// 1-  
	if (res[0]==1 && res[5]!=0)
	if (board>0)
	{
		if ((board>50 && board%2==0) || (board<51 && board%3==0))
			BltSurface(backsurf,pv[1],(x-b-5)*4,(y-a-5)*4,true);
		if ((board>50 && board%2==1) || (board<51 && board%3==1))
			BltSurface(backsurf,pv[2],(x-b-5)*4,(y-a-5)*4,true);
	}
	// 
	for(i=0;i<100;i++)
		switch (eff[i].num)
	{
		case 4:
			if (eff[i].r[0]-5-b>-10 && eff[i].r[0]-5-b<160 &&
				eff[i].r[1]-5-a>-10 && eff[i].r[1]-5-a<120){
				if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4,(eff[i].r[1]-5-a)*4,true);
				if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4,(eff[i].r[1]-5-a)*4,true);
			}
		case 1:
			if (eff[i].r[0]-5-b>-10 && eff[i].r[0]-5-b<160 &&
			eff[i].r[1]-5-a>-10 && eff[i].r[1]-5-a<120)
			{
			if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4,(eff[i].r[1]-5-a)*4,true);
			if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4,(eff[i].r[1]-5-a)*4,true);
			}
			break;
		if ((eff[i].r[0]-b)*4>-10 && (eff[i].r[0]-b)*4-20<640 &&
			(eff[i].r[1]-a)*4>-10 && (eff[i].r[1]-a)*4-21<120)
		case 2:
			if (eff[i].r[2]>2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15,(eff[i].r[1]-a)*4-21,0,0,30,42,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15,(eff[i].r[1]-a)*4-21,31,0,63,42,true);
			if (eff[i].r[2]<2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-22,(eff[i].r[1]-a)*4-21,64,0,107,42,true);
			break;
		case 3:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,192,0,255,64,true);
			break;
		case 5:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12,eff[i].r[1]*40-a*4-12,192,0,255,64,true);
			break;
	}
	//  
	if (priz[0]!=0)
		if (priz[1]%2)
		{
			if (priz[0]==1) i=0;
			if (priz[0]==2) i=3;
			if (priz[0]==3) i=5;
			if (priz[0]==4) i=8;
			if (priz[0]==5) i=9;
			BltSurface(backsurf,pv[i],(priz[2]-b-5)*4,
				(priz[3]-a-5)*4,true);
		}
	// 
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			if (tyr[j*tyrx+i]==4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4,(j*10-a)*4,true);
		}
	if (res[0]==1 && res[5]!=0)
	if (priz[0]!=0) OnPriz(a,b);//   1
	//     
	if (sotr[0]!=0)
	{
		if (sotr[1]==1)
			for(j=0;j<12;j++)
				BltSurface(backsurf,pv[49],640-sotr[0],j*40);
		else
			for(j=0;j<12;j++)
				BltSurface(backsurf,pv[49],sotr[0]-40,j*40);
	}
	}
	if (players==2)
	{
	h1=0;h2=0;
	//  1 
	// 
	a=(y-5)-60;
	b=(x-5)-80;
	if (display==0) b=(x-5)-40;
	if (display==1) b=(x-5)-40;
	if (display==2) a=(y-5)-30;
	if (display==3) a=(y-5)-30;
	if (a<0) a=0;
	if (b<0) b=0;
	if (display<2)
	if (a>(tyry-12)*10) a=(tyry-12)*10;
	if (display>1)
	if (b>(tyrx-16)*10) b=(tyrx-16)*10;
	if (display<2)
		if (b>(tyrx-8)*10) b=(tyrx-8)*10;
	if (display>1)
		if (a>(tyry-6)*10) a=(tyry-6)*10;
	if (display==0) h1=80;
	if (display==3) h2=60;
	//  
	b+=sotr[0]*(sotr[1]*2-1);
	c=a/10+13;
	d=b/10+17;
	if (display<2) d=b/10+9;
	if (display>1) c=a/10+7;
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			BltSurface(backsurf,pv[13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4);
			if (tyr[j*tyrx+i]!=3 && tyr[j*tyrx+i]!=0 && tyr[j*tyrx+i]!=4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
			if (tyr[j*tyrx+i]==3)
			{
				if ((tyrk[j*tyrx+i]&1)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
				if ((tyrk[j*tyrx+i]&2)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20+h1*4,(j*10-a)*4+h2*4,true);
				if ((tyrk[j*tyrx+i]&4)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20+h1*4,(j*10-a)*4+20+h2*4,true);
				if ((tyrk[j*tyrx+i]&8)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+20+h2*4,true);
			}
		}
	// 
		for(i=0;i<100/4;i++)
			if (patron[i*4]==1)
				if ((patron[i*4+1]>=b && patron[i*4+1]<b+80 && display<2 &&
					patron[i*4+2]>=a && patron[i*4+2]<a+120 ) ||
				 (patron[i*4+2]>=a && patron[i*4+2]<a+60 && display>1 &&
				 patron[i*4+1]>=b && patron[i*4+1]<b+160 ))
				BltSurface(backsurf,pv[4],patron[i*4+1]*4-2-b*4+h1*4,
							patron[i*4+2]*4-2-a*4+h2*4,true);
	// 
	//1- 
	if (res[0]==1 && res[5]!=0)
		if ((x-5>=b && x-5<b+80 && display<2 &&
					y-5>=a && y-5<a+120 ) ||
				 (y-5>=a && y-5<a+60 && display>1 &&
				 x-5>=b && x-5<b+160 ))
		BltSurface(backsurf,pv[20+res[2]],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
	// 
		for(i=0;i<100/4;i++)
			if (patron1[i*4]==1)
				if ((patron1[i*4+1]>=b && patron1[i*4+1]<b+80 && display<2 &&
					patron1[i*4+2]>=a && patron1[i*4+2]<a+120 ) ||
				 (patron1[i*4+2]>=a && patron1[i*4+2]<a+60 && display>1 &&
				 patron1[i*4+1]>=b && patron1[i*4+1]<b+160 ))
				BltSurface(backsurf,pv[4],patron1[i*4+1]*4-2-b*4+h1*4,
							patron1[i*4+2]*4-2-a*4+h2*4,true);
	// 
	//2- 
	if (res1[0]==1 && res1[5]!=0)
		if ((x11-5>=b-10 && x11-5<b+80 && display<2 &&
					y11-5>=a-10 && y11-5<a+120 ) ||
				 (y11-5>=a-10 && y11-5<a+60 && display>1 &&
				 x11-5>=b-10 && x11-5<b+160 ))
		BltSurface(backsurf,pv[24+res1[2]],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].r[3]!=0)
		{
			if ((vrags1[i].r[4]>=b && vrags1[i].r[4]<b+80 && display<2 &&
					vrags1[i].r[5]>=a && vrags1[i].r[5]<a+120 ) ||
				 (vrags1[i].r[5]>=a && vrags1[i].r[5]<a+60 && display>1 &&
				 vrags1[i].r[4]>=b && vrags1[i].r[4]<b+160 ))
			BltSurface(backsurf,pv[4],vrags1[i].r[4]*4-2-b*4+h1*4,
							vrags1[i].r[5]*4-2-a*4+h2*4,true);
		}
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].num!=0){
			if (vrags1[i].r[0]==4) vrags1[i].r[0]=0;
			if (vrags1[i].r[0]<0) vrags1[i].r[0]=3;
			if ((vrags1[i].x>=b-10 && vrags1[i].x<b+80 && display<2 &&
					vrags1[i].y>=a-10 && vrags1[i].y<a+120 ) ||
				 (vrags1[i].y>=a-10 && vrags1[i].y<a+60 && display>1 &&
				 vrags1[i].x>=b-10 && vrags1[i].x<b+160 ))
			BltSurface(backsurf,pv[24+vrags1[i].num*4+vrags1[i].r[0]],
			(vrags1[i].x-b-5)*4+h1*4,(vrags1[i].y-a-5)*4+h2*4,true);
		}
	// 1-  
	if (res[0]==1 && res[5]!=0)
	if ((x-5>=b && x-5<b+80 && display<2 &&
					y-5>=a && y-5<a+120 ) ||
				 (y-5>=a && y-5<a+60 && display>1 &&
				 x-5>=b && x-5<b+160 ))
	if (board>0)
	{
		if ((board>50 && board%2==0) || (board<51 && board%3==0))
			BltSurface(backsurf,pv[1],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
		if ((board>50 && board%2==1) || (board<51 && board%3==1))
			BltSurface(backsurf,pv[2],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
	}
	// 2-  
	if (res1[0]==1 && res1[5]!=0)
		if ((x11-5>=b-10 && x11-5<b+80 && display<2 &&
					y11-5>=a-10 && y11-5<a+120 ) ||
				 (y11-5>=a-10 && y11-5<a+60 && display>1 &&
				 x11-5>=b-10 && x11-5<b+160 ))
	if (board1>0)
	{
		if ((board1>50 && board1%2==0) || (board1<51 && board1%3==0))
			BltSurface(backsurf,pv[1],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
		if ((board1>50 && board1%2==1) || (board1<51 && board1%3==1))
			BltSurface(backsurf,pv[2],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
	}
	// 
	for(i=0;i<100;i++)
		switch (eff[i].num)
	{
		case 4:
			if ((eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+160 )){
				if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
				if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			}
		case 1:
		case 6:
			if ((eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+160 ))
			{
			if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			}
			break;
		case 2:
			if ((eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-20 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-20 && eff[i].r[0]-5<b+160 ))
			{
			if (eff[i].r[2]>2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15+h1*4,(eff[i].r[1]-a)*4-21+h2*4,0,0,30,42,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15+h1*4,(eff[i].r[1]-a)*4-21+h2*4,31,0,63,42,true);
			if (eff[i].r[2]<2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-22+h1*4,(eff[i].r[1]-a)*4-21+h2*4,64,0,107,42,true);
			}
			break;
		case 3:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,192,0,255,64,true);
			break;
		case 5:
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,192,0,255,64,true);
			break;
	}
	//  
	if (priz[0]!=0)
		if (priz[1]%2)
		{
			if (priz[0]==1) i=0;
			if (priz[0]==2) i=3;
			if (priz[0]==3) i=5;
			if (priz[0]==4) i=8;
			if (priz[0]==5) i=9;
			BltSurface(backsurf,pv[i],(priz[2]-b-5)*4+h1*4,
				(priz[3]-a-5)*4+h2*4,true);
		}
	// 
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			if (tyr[j*tyrx+i]==4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
		}
	if (res[0]==1 && res[5]!=0)
	if (priz[0]!=0) OnPriz(a-h2,b-h1);//   1
	//C  
	if (display==0) 
		BltSurface1(pv[50],backsurf,0,0,320,0,360,479);
	if (display==1) 
		BltSurface1(pv[50],backsurf,0,0,280,0,320,479);
	if (display==2) 
		BltSurface1(pv[51],backsurf,0,0,0,200,639,240);
	if (display==3) 
		BltSurface1(pv[51],backsurf,0,0,0,240,639,280);
	//  
	// 
	h1=0;h2=0;
	a=(y11-5)-60;
	b=(x11-5)-80;
	if (display==0) b=(x11-5)-40;
	if (display==1) b=(x11-5)-40;
	if (display==2) a=(y11-5)-30;
	if (display==3) a=(y11-5)-30;
	if (a<0) a=0;
	if (b<0) b=0;
	if (display<2)
	if (a>(tyry-12)*10) a=(tyry-12)*10;
	if (display>1)
	if (b>(tyrx-16)*10) b=(tyrx-16)*10;
	if (display<2)
		if (b>(tyrx-8)*10) b=(tyrx-8)*10;
	if (display>1)
		if (a>(tyry-6)*10) a=(tyry-6)*10;
	if (display==1) h1=80;
	if (display==2) h2=60;
	//  
	b+=sotr[0]*(sotr[1]*2-1);
	c=a/10+13;
	d=b/10+17;
	if (display<2) d=b/10+9;
	if (display>1) c=a/10+7;
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			BltSurface(backsurf,pv[13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4);
			if (tyr[j*tyrx+i]!=3 && tyr[j*tyrx+i]!=0 && tyr[j*tyrx+i]!=4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
			if (tyr[j*tyrx+i]==3)
			{
				if ((tyrk[j*tyrx+i]&1)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
				if ((tyrk[j*tyrx+i]&2)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20+h1*4,(j*10-a)*4+h2*4,true);
				if ((tyrk[j*tyrx+i]&4)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+20+h1*4,(j*10-a)*4+20+h2*4,true);
				if ((tyrk[j*tyrx+i]&8)!=0) BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+20+h2*4,true);
			}
		}
	// 
		for(i=0;i<100/4;i++)
			if (patron[i*4]==1)
				if ((patron[i*4+1]>=b && patron[i*4+1]<b+80 && display<2 &&
					patron[i*4+2]>=a && patron[i*4+2]<a+120 ) ||
				 (patron[i*4+2]>=a && patron[i*4+2]<a+60 && display>1 &&
				 patron[i*4+1]>=b && patron[i*4+1]<b+160 ))
				BltSurface(backsurf,pv[4],patron[i*4+1]*4-2-b*4+h1*4,
							patron[i*4+2]*4-2-a*4+h2*4,true);
	// 
	//1- 
	if (res[0]==1 && res[5]!=0)
		if ((x-5>=b-10 && x-5<b+80 && display<2 &&
					y-5>=a-10 && y-5<a+120 ) ||
				 (y-5>=a-10 && y-5<a+60 && display>1 &&
				 x-5>=b-10 && x-5<b+160 ))
		BltSurface(backsurf,pv[20+res[2]],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
	// 
		for(i=0;i<100/4;i++)
			if (patron1[i*4]==1)
				if ((patron1[i*4+1]>=b && patron1[i*4+1]<b+80 && display<2 &&
					patron1[i*4+2]>=a && patron1[i*4+2]<a+120 ) ||
				 (patron1[i*4+2]>=a && patron1[i*4+2]<a+60 && display>1 &&
				 patron1[i*4+1]>=b && patron1[i*4+1]<b+160 ))
				BltSurface(backsurf,pv[4],patron1[i*4+1]*4-2-b*4+h1*4,
							patron1[i*4+2]*4-2-a*4+h2*4,true);
	// 
	//2- 
	if (res1[0]==1 && res1[5]!=0)
		BltSurface(backsurf,pv[24+res1[2]],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].r[3]!=0)
		{
			if ((vrags1[i].r[4]>=b && vrags1[i].r[4]<b+80 && display<2 &&
					vrags1[i].r[5]>=a && vrags1[i].r[5]<a+120 ) ||
				 (vrags1[i].r[5]>=a && vrags1[i].r[5]<a+60 && display>1 &&
				 vrags1[i].r[4]>=b && vrags1[i].r[4]<b+160 ))
			BltSurface(backsurf,pv[4],vrags1[i].r[4]*4-2-b*4+h1*4,
							vrags1[i].r[5]*4-2-a*4+h2*4,true);
		}
	//  
	for(i=0;i<30;i++)
		if (vrags1[i].num!=0){
			if (vrags1[i].r[0]==4) vrags1[i].r[0]=0;
			if (vrags1[i].r[0]<0) vrags1[i].r[0]=3;
			if ((vrags1[i].x>=b-5 && vrags1[i].x<b+80 && display<2 &&
					vrags1[i].y>=a-5 && vrags1[i].y<a+120 ) ||
				 (vrags1[i].y>=a-5 && vrags1[i].y<a+60 && display>1 &&
				 vrags1[i].x>=b-5 && vrags1[i].x<b+160 ))
			BltSurface(backsurf,pv[24+vrags1[i].num*4+vrags1[i].r[0]],
			(vrags1[i].x-b-5)*4+h1*4,(vrags1[i].y-a-5)*4+h2*4,true);
		}
	// 1-  
	if (res[0]==1 && res[5]!=0)
		if ((x-5>=b-10 && x-5<b+80 && display<2 &&
					y-5>=a-10 && y-5<a+120 ) ||
				 (y-5>=a-10 && y-5<a+60 && display>1 &&
				 x-5>=b-10 && x-5<b+160 ))
	if (board>0)
	{
		if ((board>50 && board%2==0) || (board<51 && board%3==0))
			BltSurface(backsurf,pv[1],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
		if ((board>50 && board%2==1) || (board<51 && board%3==1))
			BltSurface(backsurf,pv[2],(x-b-5)*4+h1*4,(y-a-5)*4+h2*4,true);
	}
	// 2-  
	if (res1[0]==1 && res1[5]!=0)
		if ((x11-5>=b-10 && x11-5<b+80 && display<2 &&
					y11-5>=a-10 && y11-5<a+120 ) ||
				 (y11-5>=a-10 && y11-5<a+60 && display>1 &&
				 x11-5>=b-10 && x11-5<b+160 ))
	if (board1>0)
	{
		if ((board1>50 && board1%2==0) || (board1<51 && board1%3==0))
			BltSurface(backsurf,pv[1],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
		if ((board1>50 && board1%2==1) || (board1<51 && board1%3==1))
			BltSurface(backsurf,pv[2],(x11-b-5)*4+h1*4,(y11-a-5)*4+h2*4,true);
	}
	// 
	for(i=0;i<100;i++)
		switch (eff[i].num)
	{
		case 4:
			if ((eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+160 )){
				if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
				if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			}
		case 1:
		case 6:
			if ((eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+160 ))
			{
			if (eff[i].r[3]%2==0)
				BltSurface(backsurf,pv[6],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			if (eff[i].r[3]%2==1)
				BltSurface(backsurf,pv[7],
						(eff[i].r[0]-5-b)*4+h1*4,(eff[i].r[1]-5-a)*4+h2*4,true);
			}
			break;
		case 2:
			if ((eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+80 && display<2 &&
					eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+120 ) ||
				 (eff[i].r[1]-5>=a-10 && eff[i].r[1]-5<a+60 && display>1 &&
				 eff[i].r[0]-5>=b-10 && eff[i].r[0]-5<b+160 ))
			{
			if (eff[i].r[2]>2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15+h1*4,(eff[i].r[1]-a)*4-21+h2*4,0,0,30,42,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-15+h1*4,(eff[i].r[1]-a)*4-21+h2*4,31,0,63,42,true);
			if (eff[i].r[2]<2)
				BltSurface1(backsurf,pv[12],
				(eff[i].r[0]-b)*4-22+h1*4,(eff[i].r[1]-a)*4-21+h2*4,64,0,107,42,true);
			}
			break;
		case 3:
			if ((eff[i].r[0]*40-b*4>-40 && eff[i].r[0]*40-b*4<80*4 && display<2 &&
					eff[i].r[1]*40-a*4>-40 && eff[i].r[1]*40-a*4<120*4 ) ||
				 (eff[i].r[1]*40-a*4>-40 && eff[i].r[1]*40-a*4<60*4 && display>1 &&
				 eff[i].r[0]*40-b*4>-40 && eff[i].r[0]*40-b*4<160*4 )){
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[11],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,192,0,255,64,true);
			}
			break;
		case 5:
			if ((eff[i].r[0]*40-b*4>-40 && eff[i].r[0]*40-b*4<80*4 && display<2 &&
					eff[i].r[1]*40-a*4>-40 && eff[i].r[1]*40-a*4<120*4 ) ||
				 (eff[i].r[1]*40-a*4>-40 && eff[i].r[1]*40-a*4<60*4 && display>1 &&
				 eff[i].r[0]*40-b*4>-40 && eff[i].r[0]*40-b*4<160*4 )){
			if (eff[i].r[2]==4)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,0,0,63,64,true);
			if (eff[i].r[2]==3)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,64,0,127,64,true);
			if (eff[i].r[2]==2)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,128,0,191,64,true);
			if (eff[i].r[2]==1)
				BltSurface1(backsurf,pv[10],
				eff[i].r[0]*40-b*4-12+h1*4,eff[i].r[1]*40-a*4-12+h2*4,192,0,255,64,true);
			}
			break;
	}
	//  
	if (priz[0]!=0)
		if (priz[1]%2)
		{
			if (priz[0]==1) i=0;
			if (priz[0]==2) i=3;
			if (priz[0]==3) i=5;
			if (priz[0]==4) i=8;
			if (priz[0]==5) i=9;
			if ((priz[2]-5>=b-10 && priz[2]-5<b+80 && display<2 &&
					priz[3]-5>=a-10 && priz[3]-5<a+120 ) ||
				 (priz[3]-5>=a-10 && priz[3]-5<a+60 && display>1 &&
				 priz[2]-5>=b-10 && priz[2]-5<b+160 ))
			BltSurface(backsurf,pv[i],(priz[2]-b-5)*4+h1*4,
				(priz[3]-a-5)*4+h2*4,true);
		}
	// 
	for(j=a/10;j<c;j++)
		for(i=b/10;i<d;i++){
			if (tyr[j*tyrx+i]==4)
				BltSurface(backsurf,pv[tyr[j*tyrx+i]+13],
						(i*10-b)*4+h1*4,(j*10-a)*4+h2*4,true);
		}
	if (res1[0]==1 && res1[5]!=0)
	if (priz[0]!=0) OnPriz1(a-h2,b-h1);//   2
	//
	// 
	if (display==0) 
		BltSurface(backsurf,pv[50],320,0);
	if (display==1) 
		BltSurface(backsurf,pv[50],280,0);
	if (display==2) 
		BltSurface(backsurf,pv[51],0,200);
	if (display==3) 
		BltSurface(backsurf,pv[51],0,240);
	if (display<2)
		BltSurface(backsurf,pv[52],318,0);
	if (display>1)
		BltSurface(backsurf,pv[53],0,238);
	//     
	if (sotr[0]!=0)
	{
		if (sotr[1]==1)
			for(j=0;j<12;j++)
				BltSurface(backsurf,pv[49],640-sotr[0],j*40);
		else
			for(j=0;j<12;j++)
				BltSurface(backsurf,pv[49],sotr[0]-40,j*40);
	}
	}
	Menu_1();// 
	if (res[5]==0 && (players==1 || players==3)) OnDue();
	if (res[5]==0 && (players==2 || players==4)  && res1[5]==0) OnDue();
	if (pause) OnPause();
	primsurf->Flip(0,DDFLIP_WAIT);
	return 0;
}


int RestoreSurface()
{
	char s[256];
	DDCOLORKEY ddck,ddck1;
	ddck.dwColorSpaceLowValue=RGB(255,255,255);
	ddck.dwColorSpaceHighValue=RGB(255,255,255);
	ddck1.dwColorSpaceLowValue=RGB(0,0,0);
	ddck1.dwColorSpaceHighValue=RGB(0,0,0);
	for(int i=0;i<LEVEL1_GR;i++)
	{
		if (i==LEVEL1_GR) break;
		
			strcpy(s,level1[i]);
			if (pv[i]==NULL)
			  pv[i]=CreateSurface(s);
			if (pv[i]==NULL)
			{
				strcpy(buf,s);
				return 1;
			}
			pv[i]->SetColorKey(DDCKEY_SRCBLT,&ddck1);
			if (i==48 || i==16) 
				pv[i]->SetColorKey(DDCKEY_SRCBLT,&ddck);
			if (i==23 || i==27 || i==31 || i==35 ||
				i==39 || i==43 || i==47 )Mirror(pv[i],pv[i-2],true);
	}
	return 0;
}

int UdSurface()
{
	for(int i=0;i<LEVEL1_GR;i++)
		if (pv[i]!=NULL)
		{
			pv[i]->Release();
			pv[i]=NULL;
		}
	return 0;
}

void BltBlt(int num,int x, int y, BOOL srccolorkey)
{
	BltSurface(backsurf,pv[num],x,y,srccolorkey);
}


void BltBlt1(int num,int x, int y,int x1,int y1,int x2,int y2, BOOL srccolorkey)
{
	BltSurface1(backsurf,pv[num],x,y,x1,y1,x2,y2,srccolorkey);
}



Rest()
{
	char s[256];
	for(int i=0;i<LEVEL1_GR;i++)
	{
		if (i==LEVEL1_GR ) break;
			strcpy(s,level1[i]);
		if (pv[i]->IsLost()==false) continue;
		pv[i]->Restore();
		 LoadSurface(pv[i],s);
			if (i==23 || i==27 || i==31 || i==35 ||
				i==39 || i==43 || i==47 )Mirror(pv[i],pv[i-2],true); 
	}
}

bool Mirror(LPDIRECTDRAWSURFACE destsurf,LPDIRECTDRAWSURFACE srcsurf,BOOL srccolorkey)
{
	if (destsurf==0 || srcsurf==0)
		return FALSE;

	DDSURFACEDESC destsurfdesc;
	ZeroMemory( &destsurfdesc, sizeof(destsurfdesc) );
	destsurfdesc.dwSize = sizeof(destsurfdesc);
	destsurf->GetSurfaceDesc( &destsurfdesc );

	RECT destrect;
	destrect.left=0;
	destrect.top=0;
	destrect.right=destsurfdesc.dwWidth;
	destrect.bottom=destsurfdesc.dwHeight;

	DDBLTFX s;
	ZeroMemory( &s, sizeof(s) );
	s.dwSize=sizeof(s);
	s.dwDDFX=DDBLTFX_MIRRORUPDOWN ;
	HRESULT r;
	if (srccolorkey)
	   	s.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
		r=destsurf->Blt(&destrect, destsurf, &destrect,DDBLT_WAIT | DDBLT_DDFX,&s);
	
	return true;
}



OnPause()
{
	int i,j;
	for(i=0;i<12;i++)
		for(j=0;j<16;j++)
			BltSurface(backsurf,pv[48],j*40,i*40,true);
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[50]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,251,201,txt[0],strlen(txt[0]));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,249,199,txt[0],strlen(txt[0]));
	SetTextColor(hdc,RGB(200,200,0));
	TextOut(hdc,250,200,txt[0],strlen(txt[0]));
	backsurf->ReleaseDC(hdc);
}


OnDue()
{
	int i,j;
	for(i=0;i<12;i++)
		for(j=0;j<16;j++)
			BltSurface(backsurf,pv[48],j*40,i*40,true);
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[50]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,201,201,txt[1],strlen(txt[1]));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,199,199,txt[1],strlen(txt[1]));
	SetTextColor(hdc,RGB(200,200,0));
	TextOut(hdc,200,200,txt[1],strlen(txt[1]));
	backsurf->ReleaseDC(hdc);
}

Menu_1()
{
	HDC hdc;
	char s[256],s1[256];
	int i,b[4];
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	if (menu_1[0]){
	if (players==2){
		if (display==0)
		{
			b[0]=325;b[1]=456;b[2]=1;b[3]=456;
		}
		if (display==1)
		{
			b[0]=1;b[1]=456;b[2]=325;b[3]=456;
		}
		if (display==2)
		{
			b[0]=1;b[1]=216;b[2]=1;b[3]=456;
		}
		if (display==3)
		{
			b[0]=1;b[1]=456;b[2]=1;b[3]=216;
		}
		i=sprintf(s,"%d",res[5]);
		s1[0]=0;
		strcpy(s1,txt[2]);strcat(s1,s);
		SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,b[0]-1,b[1]-1,s1,strlen(s1));
		SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,b[0],b[1],s1,strlen(s1));
		SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,b[0]+1,b[1]+1,s1,strlen(s1));
		i=sprintf(s,"%d",res1[5]);
		s1[0]=0;
		strcpy(s1,txt[2]);strcat(s1,s);
		SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,b[2]-1,b[3]-1,s1,strlen(s1));
		SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,b[2],b[3],s1,strlen(s1));
		SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,b[2]+1,b[3]+1,s1,strlen(s1));
	}
		if (players==1 || players==3){
	i=sprintf(s,"%d",res[5]);
	s1[0]=0;
	strcpy(s1,txt[2]);strcat(s1,s);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,2,458,s1,strlen(s1));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,0,456,s1,strlen(s1));
	SetTextColor(hdc,RGB(180,180,0));
	TextOut(hdc,1,457,s1,strlen(s1));
	}
		if (players==4)
	{
			i=sprintf(s,"%d",res[5]);
	s1[0]=0;
	strcpy(s1,txt[2]);strcat(s1,s);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,2,458,s1,strlen(s1));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,0,456,s1,strlen(s1));
	SetTextColor(hdc,RGB(180,180,0));
	TextOut(hdc,1,457,s1,strlen(s1));
	i=sprintf(s,"%d",res1[5]);
	s1[0]=0;
	strcpy(s1,txt[2]);strcat(s1,s);
		SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,562,458,s1,strlen(s1));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,560,456,s1,strlen(s1));
	SetTextColor(hdc,RGB(180,180,0));
	TextOut(hdc,561,457,s1,strlen(s1));
	}
	}
	if (menu_1[1]){
	i=sprintf(s,"%d",allvrag);
	s1[0]=0;
	strcpy(s1,txt[3]);strcat(s1,s);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,2,2,s1,strlen(s1));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,0,0,s1,strlen(s1));
	SetTextColor(hdc,RGB(180,180,0));
	TextOut(hdc,1,1,s1,strlen(s1));
	}
	backsurf->ReleaseDC(hdc);
}

OnPriz(int a,int b)
{
	int xx,yy;
	xx=x-5;
	yy=(y+5);
	if (x/10>priz[2]/10) xx=x-12;
	if (x/10<priz[2]/10) xx=x+6;
	if (y/10>priz[3]/10) yy=y-10;
	//
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(0,100,100));
	TextOut(hdc,(xx-b)*4+1,(yy-a)*4+1,txt[4],strlen(txt[4]));
	SetTextColor(hdc,RGB(0,255,255));
	TextOut(hdc,(xx-b)*4-1,(yy-a)*4-1,txt[4],strlen(txt[4]));
	SetTextColor(hdc,RGB(0,180,180));
	TextOut(hdc,(xx-b)*4,(yy-a)*4,txt[4],strlen(txt[4]));
	backsurf->ReleaseDC(hdc);
}
OnPriz1(int a,int b)
{
	int xx,yy;
	xx=x11-5;
	yy=(y11+5);
	if (x11/10>priz[2]/10) xx=x11-12;
	if (x11/10<priz[2]/10) xx=x11+6;
	if (y11/10>priz[3]/10) yy=y11-10;
	//
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(0,100,100));
	TextOut(hdc,(xx-b)*4+1,(yy-a)*4+1,txt[4],strlen(txt[4]));
	SetTextColor(hdc,RGB(0,255,255));
	TextOut(hdc,(xx-b)*4-1,(yy-a)*4-1,txt[4],strlen(txt[4]));
	SetTextColor(hdc,RGB(0,180,180));
	TextOut(hdc,(xx-b)*4,(yy-a)*4,txt[4],strlen(txt[4]));
	backsurf->ReleaseDC(hdc);
}

Levels()
{
	char s[256],s1[256];
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	sprintf(s,"%d",level);
	s1[0]=0;
	strcpy(s1,txt[5]);strcat(s1,s);
	SetTextColor(hdc,RGB(60,0,0));
	TextOut(hdc,261,221,s1,strlen(s1));
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,259,219,s1,strlen(s1));
	SetTextColor(hdc,RGB(180,0,0));
	TextOut(hdc,260,220,s1,strlen(s1));
	backsurf->ReleaseDC(hdc);
}

Levels1()
{
	char s[256];
	int i,j,k;
	k=zast1/2;
	if (zast1>1000) BltSurface(backsurf,pv[28+(k%4)],0,60,true);
	if (zast1<=1000) BltSurface(backsurf,pv[29],0,60,true);
	if (zast1>800 && zast1<1000) BltSurface(backsurf,pv[32+(k%4)],0,110,true);
	if (zast1<=800) BltSurface(backsurf,pv[33],0,110,true);
	if (zast1>600 && zast1<800) BltSurface(backsurf,pv[36+(k%4)],0,160,true);
	if (zast1<=600) BltSurface(backsurf,pv[37],0,160,true);
	if (zast1>400 && zast1<600) BltSurface(backsurf,pv[40+(k%4)],0,210,true);
	if (zast1<=400) BltSurface(backsurf,pv[41],0,210,true);
	if (zast1>200 && zast1<400) BltSurface(backsurf,pv[44+(k%4)],0,260,true);
	if (zast1<=200) BltSurface(backsurf,pv[45],0,260,true);
	if (players==2 || players==4)
	{
	if (zast1>1000) BltSurface(backsurf,pv[28+(k%4)],600,60,true);
	if (zast1<=1000) BltSurface(backsurf,pv[31],600,60,true);
	if (zast1>800 && zast1<1000) BltSurface(backsurf,pv[32+(k%4)],600,110,true);
	if (zast1<=800) BltSurface(backsurf,pv[35],600,110,true);
	if (zast1>600 && zast1<800) BltSurface(backsurf,pv[36+(k%4)],600,160,true);
	if (zast1<=600) BltSurface(backsurf,pv[39],600,160,true);
	if (zast1>400 && zast1<600) BltSurface(backsurf,pv[40+(k%4)],600,210,true);
	if (zast1<=400) BltSurface(backsurf,pv[43],600,210,true);
	if (zast1>200 && zast1<400) BltSurface(backsurf,pv[44+(k%4)],600,260,true);
	if (zast1<=200) BltSurface(backsurf,pv[47],600,260,true);
	}
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(0,0,100));
	TextOut(hdc,62,3,txt[6],strlen(txt[6]));
	if (players==2 || players==4) TextOut(hdc,510,3,txt[7],strlen(txt[7]));
	SetTextColor(hdc,RGB(0,0,250));
	TextOut(hdc,59,0,txt[6],strlen(txt[6]));
	if (players==2) TextOut(hdc,507,2,txt[7],strlen(txt[7]));
	SetTextColor(hdc,RGB(0,0,180));
	TextOut(hdc,60,1,txt[6],strlen(txt[6]));
	if (players==2 || players==4) TextOut(hdc,508,1,txt[7],strlen(txt[7]));
	SetTextColor(hdc,RGB(160,0,0));
	i=res[7];
	if (i>600-k && zast1>=1000) i=600-k;
	sprintf(s,"%d",i);
	TextOut(hdc,100,60,s,strlen(s));
	if (players==2 || players==4)
	{
		i=res1[7];
		if (i>600-k && zast1>=1000) i=600-k;
		sprintf(s,"%d",i);
		TextOut(hdc,500,60,s,strlen(s));
		if (zast1<1000) {
		i=res1[8];
		if (i>500-k && zast1>=800) i=500-k;
		sprintf(s,"%d",i);
		TextOut(hdc,500,110,s,strlen(s));
		}
		if (zast1<800) {
		i=res1[9];
		if (i>400-k && zast1>=600) i=400-k;
		sprintf(s,"%d",i);
		TextOut(hdc,500,160,s,strlen(s));
		}
		if (zast1<600) {
		i=res1[10];
		if (i>300-k && zast1>=400) i=300-k;
		sprintf(s,"%d",i);
		TextOut(hdc,500,210,s,strlen(s));
		}
		if (zast1<400) {
		i=res1[11];
		if (i>200-k && zast1>=200) i=200-k;
		sprintf(s,"%d",i);
		TextOut(hdc,500,260,s,strlen(s));
		}
		if (zast1<200) 
		{
		i=res1[12];
		sprintf(s,"%d",i);
		TextOut(hdc,500,310,s,strlen(s));
		i=res1[7]*50+res1[8]*100+res1[9]*150+res1[10]*100+res1[11]*200+
			res1[12]*400;
		sprintf(s,"%d",i);
		TextOut(hdc,500,360,s,strlen(s));
		i=res1[6];
		sprintf(s,"%d",i);
		TextOut(hdc,500,410,s,strlen(s));
		}
	}
	i=0;
	if (zast1<1000) {
		i=res[8];
		if (i>500-k && zast1>=800) i=500-k;
		sprintf(s,"%d",i);
		TextOut(hdc,100,110,s,strlen(s));
	}
	i=0;
	if (zast1<800) {
		i=res[9];
		if (i>400-k && zast1>=600) i=400-k;
		sprintf(s,"%d",i);
		TextOut(hdc,100,160,s,strlen(s));
	}
	i=0;
	if (zast1<600) {
		i=res[10];
		if (i>300-k && zast1>=400) i=300-k;
		sprintf(s,"%d",i);
		TextOut(hdc,100,210,s,strlen(s));
	}
	i=0;
	if (zast1<400) {
		i=res[11];
		if (i>200-k && zast1>=200) i=200-k;
		sprintf(s,"%d",i);
		TextOut(hdc,100,260,s,strlen(s));
	}
	if (zast1<200) 
	{
		i=res[12];
		sprintf(s,"%d",i);
		TextOut(hdc,100,310,s,strlen(s));
		i=res[7]*50+res[8]*100+res[9]*150+res[10]*100+res[11]*200+
			res[12]*400;
		sprintf(s,"%d",i);
		TextOut(hdc,100,360,s,strlen(s));
		i=res[6];
		sprintf(s,"%d",i);
		TextOut(hdc,100,410,s,strlen(s));
		SetTextColor(hdc,RGB(160,160,160));
		TextOut(hdc,0,310,txt[4],strlen(txt[4]));
		TextOut(hdc,0,360,txt[8],strlen(txt[8]));
		TextOut(hdc,0,410,txt[9],strlen(txt[9]));
	}
	backsurf->ReleaseDC(hdc);
}

Menu()
{
	SIZE siz;
	char s[256],s2[256];
	char s1[2]=
	{
		95,0
	};
	int i,j;
	unsigned long k;
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[90]);
	SetBkMode(hdc,TRANSPARENT);
	for(i=0;i<256;i++)
	{
		if (name1[i]==0)
		{
			s[i]=0;
			break;
		}
		s[i]=name1[i]-100;
	}
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,0,0,s,strlen(s));
	SetTextColor(hdc,RGB(100,0,0));
	TextOut(hdc,2,2,s,strlen(s));
	SetTextColor(hdc,RGB(170,0,0));
	TextOut(hdc,1,1,s,strlen(s));
	SelectObject(hdc,font[80]);
	SetBkMode(hdc,TRANSPARENT);
	for(i=0;i<256;i++)
	{
		if (name2[i]==0)
		{
			s[i]=0;
			break;
		}
		s[i]=name2[i]-100;
	}
	SetTextColor(hdc,RGB(140,255,140));
	TextOut(hdc,100,60,s,strlen(s));
	SetTextColor(hdc,RGB(40,100,40));
	TextOut(hdc,102,62,s,strlen(s));
	SetTextColor(hdc,RGB(80,185,80));
	TextOut(hdc,101,61,s,strlen(s));
	SelectObject(hdc,font[15]);
	SetBkMode(hdc,TRANSPARENT);
	for(i=0;i<256;i++)
	{
		if (name4[i]==0)
		{
			s[i]=0;
			break;
		}
		s[i]=name4[i]-100;
	}
	lstrcpy(s2,s);lstrcat(s2," ");
	for(i=0;i<256;i++)
	{
		if (name[i]==0)
		{
			s[i]=0;
			break;
		}
		s[i]=name[i]-100;
	}
	lstrcat(s2,s);
	SetTextColor(hdc,RGB(185,185,185));
	TextOut(hdc,1,464,s2,strlen(s2));
	// 
	if (zast==9)
	{
		SelectObject(hdc,font[20]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,255,0));
		if (reserved[3]==0)
			TextOut(hdc,200,140,"DATA\\inf.txt - ?",16);
		else
		{
			zast1--;
			if (zast1==0) zast1=reserved[3]*30+15*30;
			FILE *f;
			f=fopen("DATA\\inf.txt","r");
			if (reserved[3]>zast1/30)
				for(i=0;i<reserved[3]-zast1/30;i++)
					fgets(s,256,f);
			for(i=0;i<15;i++)
			{
				if (reserved[3]+i>=zast1/30 && zast1/30-2>=i)
				{
					fgets(s,256,f);
					s[strlen(s)-1]=0;
					TextOut(hdc,150,140+i*20,s,strlen(s));
				}
			}
			fclose(f);
		}
	}
	if (zast==7)
	{
		if (zast1<15) i=24+zast1;
		if (zast1==15) i=23;
		SelectObject(hdc,font[20]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,255,0));
			TextOut(hdc,249,139+zast1*20,txt[i],strlen(txt[i]));
		SetTextColor(hdc,RGB(255,0,0));
		TextOut(hdc,250,140,txt[24],strlen(txt[24]));
		TextOut(hdc,250,160,txt[25],strlen(txt[25]));
		TextOut(hdc,250,180,txt[26],strlen(txt[26]));
		TextOut(hdc,250,200,txt[27],strlen(txt[27]));
		TextOut(hdc,250,220,txt[28],strlen(txt[28]));
		TextOut(hdc,250,240,txt[29],strlen(txt[29]));
		TextOut(hdc,250,260,txt[30],strlen(txt[30]));
		TextOut(hdc,250,280,txt[31],strlen(txt[31]));
		TextOut(hdc,250,300,txt[32],strlen(txt[32]));
		TextOut(hdc,250,320,txt[33],strlen(txt[33]));
		TextOut(hdc,250,340,txt[34],strlen(txt[34]));
		TextOut(hdc,250,360,txt[35],strlen(txt[35]));
		TextOut(hdc,250,380,txt[36],strlen(txt[36]));
		TextOut(hdc,250,400,txt[37],strlen(txt[37]));
		TextOut(hdc,250,420,txt[38],strlen(txt[38]));
		TextOut(hdc,250,440,txt[23],strlen(txt[23]));
		SetTextColor(hdc,RGB(0,255,255));
		strcpy(s,Klavi(keyb[1]));
		if (zast1==0 && reserved[2]==1)
		{
			if (timer%4<2)
			TextOut(hdc,350,140,s1,strlen(s1));
		}
		else TextOut(hdc,350,140,s,strlen(s));
		strcpy(s,Klavi(keyb[2]));
		if (zast1==1 && reserved[2]==1) 
			{
			if (timer%4<2) TextOut(hdc,350,160,s1,strlen(s1));
		}
		else TextOut(hdc,350,160,s,strlen(s));
		strcpy(s,Klavi(keyb[3]));
		if (zast1==2 && reserved[2]==1)
		{
			if (timer%4<2) TextOut(hdc,350,180,s1,strlen(s1));
		}
		else TextOut(hdc,350,180,s,strlen(s));
		strcpy(s,Klavi(keyb[4]));
		if (zast1==3 && reserved[2]==1)
		{
			if (timer%4<2) TextOut(hdc,350,200,s1,strlen(s1));
		}
		else TextOut(hdc,350,200,s,strlen(s));
		strcpy(s,Klavi(keyb[5]));
		if (zast1==4 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,220,s1,strlen(s1));
		}
		else TextOut(hdc,350,220,s,strlen(s));
		strcpy(s,Klavi(keyb[14]));
		if (zast1==5 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,240,s1,strlen(s1));
		}
		else TextOut(hdc,350,240,s,strlen(s));
		strcpy(s,Klavi(keyb[6]));
		if (zast1==6 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,260,s1,strlen(s1));
		}
		else TextOut(hdc,350,260,s,strlen(s));
		strcpy(s,Klavi(keyb[7]));
		if (zast1==7 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,280,s1,strlen(s1));
		}
		else TextOut(hdc,350,280,s,strlen(s));
		strcpy(s,Klavi(keyb[8]));
		if (zast1==8 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,300,s1,strlen(s1));
		}
		else TextOut(hdc,350,300,s,strlen(s));
		strcpy(s,Klavi(keyb[9]));
		if (zast1==9 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,320,s1,strlen(s1));
		}
		else TextOut(hdc,350,320,s,strlen(s));
		strcpy(s,Klavi(keyb[10]));
		if (zast1==10 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,340,s1,strlen(s1));
		}
		else TextOut(hdc,350,340,s,strlen(s));
		strcpy(s,Klavi(keyb[13]));
		if (zast1==11 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,360,s1,strlen(s1));
		}
		else TextOut(hdc,350,360,s,strlen(s));
		strcpy(s,Klavi(keyb[11]));
		if (zast1==12 && reserved[2]==1) 
			{
			if (timer%4<2) TextOut(hdc,350,380,s1,strlen(s1));
		}
		else TextOut(hdc,350,380,s,strlen(s));
		strcpy(s,Klavi(keyb[12]));
		if (zast1==13 && reserved[2]==1)
			{
			if (timer%4<2) TextOut(hdc,350,400,s1,strlen(s1));
		}
		else TextOut(hdc,350,400,s,strlen(s));
	}
	if (zast==6)
	{
		if (zast1==0) i=17;
		if (zast1==1) i=18;
		if (zast1==2) i=21;
		if (zast1==3) i=22;
		if (zast1==4) i=23;
		SelectObject(hdc,font[40]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,250-80,160+zast1*40,txt[i],strlen(txt[i]));
		SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,250-80,162+zast1*40,txt[i],strlen(txt[i]));
		SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,250-80,161+zast1*40,txt[i],strlen(txt[i]));
		SetTextColor(hdc,RGB(255,0,0));
		if (zast1!=0) TextOut(hdc,250-80,160,txt[17],strlen(txt[17]));
		if (zast1!=1) TextOut(hdc,250-80,200,txt[18],strlen(txt[18]));
		if (zast1!=2) TextOut(hdc,250-80,240,txt[21],strlen(txt[21]));
		if (zast1!=3) TextOut(hdc,250-80,280,txt[22],strlen(txt[22]));
		if (zast1!=4) TextOut(hdc,250-80,320,txt[23],strlen(txt[23]));
		SetTextColor(hdc,RGB(100,0,0));
		if (zast1!=0) TextOut(hdc,252-80,162,txt[17],strlen(txt[17]));
		if (zast1!=1) TextOut(hdc,252-80,202,txt[18],strlen(txt[18]));
		if (zast1!=2) TextOut(hdc,252-80,242,txt[21],strlen(txt[21]));
		if (zast1!=3) TextOut(hdc,252-80,282,txt[22],strlen(txt[22]));
		if (zast1!=4) TextOut(hdc,252-80,322,txt[23],strlen(txt[23]));
		SetTextColor(hdc,RGB(180,0,0));
		if (zast1!=0) TextOut(hdc,251-80,161,txt[17],strlen(txt[17]));
		if (zast1!=1) TextOut(hdc,251-80,201,txt[18],strlen(txt[18]));
		if (zast1!=2) TextOut(hdc,251-80,241,txt[21],strlen(txt[21]));
		if (zast1!=3) TextOut(hdc,251-80,281,txt[22],strlen(txt[22]));
		if (zast1!=4) TextOut(hdc,251-80,321,txt[23],strlen(txt[23]));
		SetTextColor(hdc,RGB(0,255,255));
		if (soundbl && sound) TextOut(hdc,490-80,160,txt[19],strlen(txt[19]));
		if (!soundbl || !sound) TextOut(hdc,490-80,160,txt[20],strlen(txt[20]));
		s[0]=0;
		sprintf(s,"%d",level);
		TextOut(hdc,490-50,280,s,strlen(s));
	}
	if (zast==4)
	{
		//  
		SelectObject(hdc,font[40]);
		SetBkMode(hdc,TRANSPARENT);
		//1
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,160,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,195,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,230,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,265,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,300,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,335,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,370,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,405,txt[15],strlen(txt[15]));
		//2
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,162,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,197,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,232,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,267,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,302,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,337,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,372,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,407,txt[15],strlen(txt[15]));
		//3
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,161,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,196,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,231,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,266,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,301,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,336,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,371,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,406,txt[15],strlen(txt[15]));
	}
	if (zast==10 && zast1!=0)
	{
		SelectObject(hdc,font[40]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,255,0));
		if (zast1==1)
			TextOut(hdc,150,160,txt[6],strlen(txt[6]));
		if (zast1==2)
			TextOut(hdc,150,160,txt[7],strlen(txt[7]));
		TextOut(hdc,300,160,txt[41],strlen(txt[41]));
		SetTextColor(hdc,RGB(100,100,0));
		if (zast1==1)
			TextOut(hdc,152,162,txt[6],strlen(txt[6]));
		if (zast1==2)
			TextOut(hdc,152,162,txt[7],strlen(txt[7]));
		TextOut(hdc,302,162,txt[41],strlen(txt[41]));
		SetTextColor(hdc,RGB(180,180,0));
		if (zast1==1)
			TextOut(hdc,151,161,txt[6],strlen(txt[6]));
		if (zast1==2)
			TextOut(hdc,151,161,txt[7],strlen(txt[7]));
		TextOut(hdc,301,161,txt[41],strlen(txt[41]));
		for(i=0;i<reserved[6];i++) s[i]=buffer[i];
		s[reserved[6]]=0;
		SetTextColor(hdc,RGB(180,180,180));
		TextOut(hdc,200,250,s,strlen(s));
		SetTextColor(hdc,RGB(0,250,250));
		if (timer%4<2)
			TextOut(hdc,200+reserved[6]*16,250,s1,strlen(s1));
	}
	if (zast==8)
	{
		SelectObject(hdc,font[40]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,250,160,txt[40],strlen(txt[40]));
		SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,252,162,txt[40],strlen(txt[40]));
		SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,251,161,txt[40],strlen(txt[40]));
		SelectObject(hdc,font[20]);
		SetTextColor(hdc,RGB(255,0,255));
		for(i=0;i<10;i++)
		{
			for(j=0;j<10;j++)
				s[j]=records[j+i*14]+32;
			s[10]=0;
			TextOut(hdc,200,200+i*20,s,strlen(s));
			k=((records[i*14+10]*256+records[i*14+11])*256
				+records[i*14+12])*256+records[i*14+13];
			sprintf(s,"%d",k);
			TextOut(hdc,400,200+i*20,s,strlen(s));
		}
	}
	if (zast==5)
	{
		SelectObject(hdc,font[40]);
		SetBkMode(hdc,TRANSPARENT);
		//1
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[39],lstrlen(txt[39]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,160,txt[39],strlen(txt[39]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,195,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,230,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,265,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,300,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,335,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,370,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,405,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(255,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==8) SetTextColor(hdc,RGB(255,255,0));
		TextOut(hdc,(640-siz.cx)/2-1,440,txt[15],strlen(txt[15]));
		//2
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[39],lstrlen(txt[39]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,162,txt[39],strlen(txt[39]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,197,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,232,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,267,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,302,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,337,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,372,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,407,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(100,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==8) SetTextColor(hdc,RGB(100,100,0));
		TextOut(hdc,(640-siz.cx)/2+1,442,txt[15],strlen(txt[15]));
		//3
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[39],lstrlen(txt[39]),&siz);
		if (zast1==0) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,161,txt[39],strlen(txt[39]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[10],lstrlen(txt[10]),&siz);
		if (zast1==1) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,196,txt[10],strlen(txt[10]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[11],lstrlen(txt[11]),&siz);
		if (zast1==2) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,231,txt[11],strlen(txt[11]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[42],lstrlen(txt[42]),&siz);
		if (zast1==3) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,266,txt[42],strlen(txt[42]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[43],lstrlen(txt[43]),&siz);
		if (zast1==4) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,301,txt[43],strlen(txt[43]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[12],lstrlen(txt[12]),&siz);
		if (zast1==5) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,336,txt[12],strlen(txt[12]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[13],lstrlen(txt[13]),&siz);
		if (zast1==6) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,371,txt[13],strlen(txt[13]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[14],lstrlen(txt[14]),&siz);
		if (zast1==7) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,406,txt[14],strlen(txt[14]));
		SetTextColor(hdc,RGB(180,0,0));
		GetTextExtentPoint32(hdc,txt[15],lstrlen(txt[15]),&siz);
		if (zast1==8) SetTextColor(hdc,RGB(180,180,0));
		TextOut(hdc,(640-siz.cx)/2,441,txt[15],strlen(txt[15]));
	}
	backsurf->ReleaseDC(hdc);
	if (zast==6)
	{
		//  
		BltSurface(backsurf,pv[54],490-80,210);
		BltSurface(backsurf,pv[55],492-80+95*(svolum-DSBVOLUME_MIN/10)/(DSBVOLUME_MAX-DSBVOLUME_MIN/10),212);
	}
}