//DirectInput
#include "stdafx.h"

IDirectInput *dinput=NULL;
IDirectInputDevice *keyboard=NULL;
HINSTANCE hInst=NULL;
HRESULT r;

char* Klavi(int kl);

int DirectInputC(HWND h)
{
	// DirectInput - 
	r=DirectInputCreate(hInst,DIRECTINPUT_VERSION,&dinput,NULL);
	if (r!=DI_OK) return 1;
	r=dinput->CreateDevice(GUID_SysKeyboard,&keyboard,0);
	if (r!=DI_OK) return 2;
	r=keyboard->SetDataFormat(&c_dfDIKeyboard);
	if (r!=DI_OK) return 3;
	r=keyboard->SetCooperativeLevel(h,DISCL_FOREGROUND | 
		                            DISCL_NONEXCLUSIVE | DISCL_NOWINKEY);
	if (r!=DI_OK) return 4;
	return 0;
}

int DirectActive()
{
	if (keyboard) r=keyboard->Acquire();
	while( r == DIERR_INPUTLOST || 
                   r == E_ACCESSDENIED  ) 
        {
                r = keyboard->Acquire();
        }
	if (r!=DI_OK) return 1;
	return 0;
}

int DirectDeActive()
{
	if (keyboard) 
	{
		keyboard->Unacquire();
		keyboard->Release();
		keyboard=NULL;
	}
	if (dinput)
	{
		dinput->Release();
	    dinput=NULL;
	}
	return 0;
}

int DirectDeActive1()
{
	//if (keyboard) keyboard->Unacquire();
	return 0;
}

char* DINPUT(HWND h)
{
	HRESULT r;
	static char key[256];
	r=keyboard->GetDeviceState(sizeof(key),&key);
	if (r!=DI_OK)
	{
		r = keyboard->Acquire();
        while( r == DIERR_INPUTLOST || 
                   r == E_ACCESSDENIED  ) 
        {
                r = keyboard->Acquire();
				r=keyboard->GetDeviceState(sizeof(key),&key);
        }
	}
	return key;
}

char* Klavi(int kl)
{
	char buf[256];
	strcpy(buf,"some key");
	if (kl==DIK_1) strcpy(buf,"1");
	if (kl==DIK_2) strcpy(buf,"2");
	if (kl==DIK_3) strcpy(buf,"3");
	if (kl==DIK_4) strcpy(buf,"4");
	if (kl==DIK_5) strcpy(buf,"5");
	if (kl==DIK_6) strcpy(buf,"6");
	if (kl==DIK_7) strcpy(buf,"7");
	if (kl==DIK_8) strcpy(buf,"8");
	if (kl==DIK_9) strcpy(buf,"9");
	if (kl==DIK_0) strcpy(buf,"0");
	if (kl==DIK_MINUS) strcpy(buf,"-");
	if (kl==DIK_EQUALS) strcpy(buf,"=");
	if (kl==DIK_BACK) strcpy(buf,"BACKSPACE");
	if (kl==DIK_TAB) strcpy(buf,"TAB");
	if (kl==DIK_Q) strcpy(buf,"Q");
	if (kl==DIK_W) strcpy(buf,"W");
	if (kl==DIK_E) strcpy(buf,"E");
	if (kl==DIK_R) strcpy(buf,"R");
	if (kl==DIK_T) strcpy(buf,"T");
	if (kl==DIK_Y) strcpy(buf,"Y");
	if (kl==DIK_U) strcpy(buf,"U");
	if (kl==DIK_I) strcpy(buf,"I");
	if (kl==DIK_O) strcpy(buf,"O");
	if (kl==DIK_P) strcpy(buf,"P");
	if (kl==DIK_LBRACKET) strcpy(buf,"[");
	if (kl==DIK_RBRACKET) strcpy(buf,"]");
	if (kl==DIK_RETURN) strcpy(buf,"ENTER");
	if (kl==DIK_LCONTROL) strcpy(buf,"LEFT CTRL");
	if (kl==DIK_A) strcpy(buf,"A");
	if (kl==DIK_S) strcpy(buf,"S");
	if (kl==DIK_D) strcpy(buf,"D");
	if (kl==DIK_F) strcpy(buf,"F");
	if (kl==DIK_G) strcpy(buf,"G");
	if (kl==DIK_H) strcpy(buf,"H");
	if (kl==DIK_J) strcpy(buf,"J");
	if (kl==DIK_K) strcpy(buf,"K");
	if (kl==DIK_L) strcpy(buf,"L");
	if (kl==DIK_SEMICOLON) strcpy(buf,";");
	if (kl==DIK_APOSTROPHE) strcpy(buf,"'");
	if (kl==DIK_GRAVE) strcpy(buf,"GRAVE");
	if (kl==DIK_BACKSLASH) strcpy(buf,"\\");
	if (kl==DIK_Z) strcpy(buf,"Z");
	if (kl==DIK_X) strcpy(buf,"X");
	if (kl==DIK_C) strcpy(buf,"C");
	if (kl==DIK_V) strcpy(buf,"V");
	if (kl==DIK_B) strcpy(buf,"B");
	if (kl==DIK_N) strcpy(buf,"N");
	if (kl==DIK_M) strcpy(buf,"M");
	if (kl==DIK_COMMA) strcpy(buf,",");
	if (kl==DIK_PERIOD) strcpy(buf,".");
	if (kl==DIK_SLASH) strcpy(buf,"/");
	if (kl==DIK_RSHIFT) strcpy(buf,"RIGHT SHIFT");
	if (kl==DIK_MULTIPLY) strcpy(buf,"*(NUM)");
	if (kl==DIK_LMENU) strcpy(buf,"LEFT ALT");
	if (kl==DIK_SPACE) strcpy(buf,"SPACE");
	if (kl==DIK_CAPITAL) strcpy(buf,"CAPITAL");
	if (kl==DIK_LSHIFT) strcpy(buf,"LEFT SHIFT");
	if (kl==DIK_RMENU) strcpy(buf,"RIGHT ALT");
	if (kl==DIK_RCONTROL) strcpy(buf,"RIGHT CTRL");
	if (kl==DIK_UP) strcpy(buf,"UP ARROW");
	if (kl==DIK_DOWN) strcpy(buf,"DOWN ARROW");
	if (kl==DIK_LEFT) strcpy(buf,"LEFT ARROW");
	if (kl==DIK_RIGHT) strcpy(buf,"RIGHT ARROW");
	if (kl==DIK_NUMPAD1) strcpy(buf,"1(NUM)");
	if (kl==DIK_NUMPAD2) strcpy(buf,"2(NUM)");
	if (kl==DIK_NUMPAD3) strcpy(buf,"3(NUM)");
	if (kl==DIK_NUMPAD4) strcpy(buf,"4(NUM)");
	if (kl==DIK_NUMPAD5) strcpy(buf,"5(NUM)");
	if (kl==DIK_NUMPAD6) strcpy(buf,"6(NUM)");
	if (kl==DIK_NUMPAD7) strcpy(buf,"7(NUM)");
	if (kl==DIK_NUMPAD8) strcpy(buf,"8(NUM)");
	if (kl==DIK_NUMPAD9) strcpy(buf,"9(NUM)");
	if (kl==DIK_NUMPAD0) strcpy(buf,"0(NUM)");
	if (kl==DIK_SUBTRACT) strcpy(buf,"-(NUM)");
	if (kl==DIK_ADD) strcpy(buf,"+(NUM)");
	if (kl==DIK_DECIMAL) strcpy(buf,".(NUM)");
	if (kl==DIK_NUMPADENTER) strcpy(buf,"ENTER(NUM)");
	if (kl==DIK_INSERT) strcpy(buf,"INSERT");
	if (kl==DIK_DELETE) strcpy(buf,"DELETE");
	if (kl==DIK_NEXT) strcpy(buf,"PAGE DOWN");
	if (kl==DIK_PRIOR) strcpy(buf,"PAGE UP");
	if (kl==DIK_HOME) strcpy(buf,"HOME");
	if (kl==DIK_END) strcpy(buf,"END");
	if (kl==DIK_F1) strcpy(buf,"F1");
	if (kl==DIK_F2) strcpy(buf,"F2");
	if (kl==DIK_F3) strcpy(buf,"F3");
	if (kl==DIK_F4) strcpy(buf,"F4");
	if (kl==DIK_F5) strcpy(buf,"F5");
	if (kl==DIK_F6) strcpy(buf,"F6");
	if (kl==DIK_F7) strcpy(buf,"F7");
	if (kl==DIK_F8) strcpy(buf,"F8");
	if (kl==DIK_F9) strcpy(buf,"F9");
	if (kl==DIK_F10) strcpy(buf,"F10");
	if (kl==DIK_F11) strcpy(buf,"F11");
	if (kl==DIK_F12) strcpy(buf,"F12");
	if (kl==DIK_PAUSE) strcpy(buf,"BREAK(PAUSE)");
	return buf;
}