//DirectSound
#include "stdafx.h"
#include "sound.h"


IDirectSound *DirectSound=NULL;
LPDIRECTSOUNDBUFFER sd[SHLEV1];//,ms;

LPDIRECTSOUNDBUFFER CreateSoundBuf(unsigned long size,
									  WAVEFORMATEX wfx);
WAVEFORMATEX CreateWfx(WORD wFT,WORD nC,DWORD nS,
					   DWORD nA,WORD nB,WORD nBP);
LPDIRECTSOUNDBUFFER CreateSoundB(char *filename);
int DSOUND(int h);
int DSOUND1(int h);
int UdSound();
int LoadSound();
//DNone();
int k=0;
//int mus,mus1;
FILE *hFile;

extern char buf[256];

int DirectSoundC(HWND h)
{
	for(int i=0;i<SHLEV1;i++) sd[i]=NULL;
	HRESULT r;
	r=DirectSoundCreate(NULL,&DirectSound,0);
	if (r!=DS_OK) return 1;
	r=DirectSound->SetCooperativeLevel(h,DSSCL_PRIORITY);
	if (r!=DS_OK) return 2;
	//mus=0;mus1=0;
	/*WAVEFORMATEX wfx;
	wfx.wFormatTag=WAVE_FORMAT_PCM;
	wfx.nChannels=2;
	wfx.nSamplesPerSec=44100;
	wfx.nBlockAlign=4;
	wfx.nAvgBytesPerSec=176400;
	wfx.wBitsPerSample=16;
	wfx.cbSize=0;
	ms=CreateSoundBuf(40000,wfx);
	void *ptr;
	char *p;
	DWORD *uk,size,readed;
	//hFile=CreateFile("san.wav",GENERIC_READ,FILE_SHARE_READ,0,
	//	OPEN_EXISTING,0,0);
	hFile=fopen("san.wav","rb");
	r=ms->Lock(0,0,&ptr,&size,0,0,DSBLOCK_ENTIREBUFFER);
	if (r!=DS_OK) return 0;
	//ReadFile(hFile,ptr,size/2,&readed,0);
	//if (hFile!=INVALID_HANDLE_VALUE) 
	//	 CloseHandle(hFile);
	fread(ptr,1,size/2,hFile);
	fclose(hFile);
  	ms->Unlock(ptr,size,0,0);
	if (r!=DS_OK) return 0;
	ms->Play(0,0,DSBPLAY_LOOPING);
	return 0;*/
}

int DirectSoundEnd(HWND h)
{
	for(int i=0;i<SHLEV1;i++) if (sd[i]) sd[i]->Release();
	if (DirectSound) 
	{
		DirectSound->Release();
	    DirectSound=NULL;
	}
	return 0;
}


LPDIRECTSOUNDBUFFER CreateSoundBuf(unsigned long size,
									  WAVEFORMATEX wfx)
{
	LPDIRECTSOUNDBUFFER DSB;
	DSBUFFERDESC dsbd;
	HRESULT r;

	ZeroMemory((void*)&dsbd,sizeof(dsbd));
	dsbd.dwSize=sizeof(dsbd);
	dsbd.dwFlags=DSBCAPS_CTRLVOLUME;
	dsbd.dwBufferBytes=size;
	dsbd.dwReserved=0;
	dsbd.lpwfxFormat=&wfx;

	r=DirectSound->CreateSoundBuffer(&dsbd,&DSB,0);
	if (r!=DS_OK) return 0;

	return DSB;
}

WAVEFORMATEX CreateWfx(WORD wFT,WORD nC,DWORD nS,
					   DWORD nA,WORD nB,WORD nBP)
{
	WAVEFORMATEX wfx;

	wfx.wFormatTag=wFT;
	wfx.nChannels=nC;
	wfx.nSamplesPerSec=nS;
	wfx.nBlockAlign=nB;
	wfx.nAvgBytesPerSec=nA;
	wfx.wBitsPerSample=nBP;
	wfx.cbSize=0;

	return wfx;
}

LPDIRECTSOUNDBUFFER CreateSoundB(char *filename)
{
	LPDIRECTSOUNDBUFFER DSB;
	WAVEFORMATEX wfx;
	void *ptr;
	char *p;
	DWORD *uk,readed;
	char buf[256],buf1[256],buf2[256];
	char *a[256];
	unsigned char buffer[1000];
	unsigned long amount,i,j,k,l,size1;
	long size,size0;
	DWORD g;
	int h;
	k=0;
	strcpy(buf1,filename);
	for(h=0;h<strlen(buf1);h++) if (buf1[h]>6*16) buf1[h]-=2*16;
	size=0;size0=0;
	HANDLE hFile=INVALID_HANDLE_VALUE;
	hFile=CreateFile("pak2.pak",GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,0);
	if (hFile==INVALID_HANDLE_VALUE) {
		//strcpy(buf1,"   ");
		//strcat(buf1,filename);
		//MessageBox(0,buf1,"Error",MB_OK);
		k=1;
		return DSB;
	}
	//pak
	ReadFile(hFile,&amount,4,&g,0);
	ReadFile(hFile,&a,1,&g,0);
	l=0;
	for(i=0;i<amount;i++)
	{
		j=0;
		do{
			ReadFile(hFile,&buf[j],1,&g,0);;
			if (buf[j]==0x0A)
			{
				buf[j]=0;
				break;
			}
			j++;
		}while(true);
		ReadFile(hFile,&k,4,&g,0);
		ReadFile(hFile,&a,1,&g,0);
		for(h=0;h<strlen(buf);h++) if (buf[h]>6*16) buf[h]-=2*16;
		if (strcmp(buf,buf1)==0) {
			l=1;size1=k;
		}
		if (l==0) {
			size+=k;
			if (size>256*256*256)
			{
				size0+=size/(256*256*256);
				size=size % (256*256*256);
			}
		}
	}
	size=SetFilePointer(hFile,size,&size0,FILE_CURRENT);
	//pak
	ReadFile(hFile,buf,4,&readed,0);
	ReadFile(hFile,(void*)buf,4,&readed,0);
	ReadFile(hFile,(void*)buf,4,&readed,0);
	if (buf[0]!='W' || buf[1]!='A' || buf[2]!='V' || buf[3]!='E')
	{
		//strcpy(buf1," WAV ");
		//strcat(buf1,filename);
		//MessageBox(0,buf1,"Error",MB_OK);
		k=1;
		return 0;
	}
	ReadFile(hFile,(void*)buf,4,&readed,0);
	if (buf[0]!='f' || buf[1]!='m' || buf[2]!='t' || buf[3]!=' ')
	{
		//strcpy(buf1," WAV ");
		//strcat(buf1,filename);
		//MessageBox(0,buf1,"Error",MB_OK);
		k=1;
		return 0;
	}
	ReadFile(hFile,(void*)buf,4,&readed,0);
	uk=(DWORD*)buf;
	size1=uk[0];
	if (size1>18) size1=18;
	ReadFile(hFile,(void*)buffer,size1,&readed,0);
	wfx=CreateWfx(*((WORD*)buffer),*((WORD*)buffer+1),
		*((DWORD*)buffer+1),*((DWORD*)buffer+2),
		*((WORD*)buffer+6),*((WORD*)buffer+7) );
	i=0;
	if (wfx.cbSize!=0)
		do{
			ReadFile(hFile,(void*)buffer,1,&readed,0);
			i++;
			if (i==wfx.cbSize) break;
		}while(true);
	// data
	do{
		ReadFile(hFile,(void*)buf,1,&readed,0);
		if (buf[0]=='d'){
			ReadFile(hFile,(void*)buf,1,&readed,0);
		    if (buf[0]=='a')
			{
				ReadFile(hFile,(void*)buf,1,&readed,0);
				if (buf[0]=='t')
				{
					ReadFile(hFile,(void*)buf,1,&readed,0);
					if (buf[0]=='a')
						break;
				}
			}
		}
	}while(true);
	/*ReadFile(hFile,(void*)buf,4,&readed,0);
	if (buf[0]!='d' || buf[1]!='a' || buf[2]!='t' || buf[3]!='a')
	{
		//strcpy(buf1," ");
		//strcat(buf1,filename);
		//MessageBox(0,buf1,"Error",MB_OK);
		k=1;
		return 0;
	}*/
	ReadFile(hFile,(void*)buf,4,&readed,0);
	size1=*((DWORD*)buf);
	DSB=CreateSoundBuf(size1,wfx);
	if (DSB==NULL) return 0;
	//	//
	HRESULT r;
	r=DSB->Lock(0,0,&ptr,&size1,0,0,DSBLOCK_ENTIREBUFFER);
	if (r!=DS_OK) return 0;
	ReadFile(hFile,ptr,size1,&readed,0);
	if (hFile!=INVALID_HANDLE_VALUE) 
		 CloseHandle(hFile);
  	DSB->Unlock(ptr,size1,0,0);
	if (r!=DS_OK) return 0;
	return DSB;
}

int DSOUND(int h)
{
 
	sd[h]->SetCurrentPosition(0); 
	sd[h]->Stop();
	sd[h]->Play(0,0,0);
	return 0;
}

int DSOUND1(int h)
{
	DWORD d;
	sd[h]->GetStatus(&d);
	if (d==DSBSTATUS_PLAYING) return 1;
	return 0;
}


int UdSound()
{
	for(int i=0;i<SHLEV1;i++) if (sd[i]!=NULL) sd[i]->Release();
	return 0;
}



int LoadSound()
{
	char s[256]; 
	for(int i=0;i<SHLEV1;i++)
	{
		strcpy(s,soundb[i]);
		sd[i]=CreateSoundB(s);
		if (k==1 ||  sd[i]==NULL)
		{
				strcpy(buf,s);
				return 1;
		}
	}
	return 0;
}
